// Modification of protoparser.js, copyright (c) 2019-2020 Nikita Tseykovets <tseikovets@rambler.ru>, licensed under the MIT license.
// version 6(145)

// This code has been moved to the main file.
/*
function parser(input){input=input.toLowerCase().slice(game.prompt.length);var words=input.trim().replace(/[^0-9a-zힺ ]/g, '').split(/\s+/);
	if(words.length > 2) {
		for(var i in game.ignoredPrepositions) {
			var prep = words.indexOf(game.ignoredPrepositions[i])
			if(prep >= 0)
				words.splice(prep, 1)
		}
	}
if(words.length>2)return t.print(game.longCommandMsg)
if(words=='')return t.print(game.emptyCommandMsg)
var verb=words[0];var noun=words[1];for(var com in gameCommands)
if(gameCommands[com][1].indexOf(verb)!=-1)return choiceHandler(gameCommands[com][0],gameCommands[com][2],noun,verb,gameCommands[com][3]=='noun'?noun:gameCommands[com][3]=='verb'?verb:gameCommands[com][3])
t.print(game.unknownCommandMsg)}
*/

// This code has been moved to the main file.
/*
function examine (obj) {
	var roomDesc;
	if(obj === undefined) {
		var objInRoom = getObjByKV('loc', player.loc);
		var objWithSceneDesc = objInRoom.filter(function(obj) {
			return obj.sceneDesc && !obj.hidden
		})
		var nonHiddenObj = objInRoom.filter(function(obj) {
			return !obj.hidden && !obj.sceneDesc
		})
		var objDesc = ''
		for(var i in objWithSceneDesc)
			objDesc += ' '+objWithSceneDesc[i].sceneDesc
		var objNames = '<br>'+game.placedHereMsg;
		for(var i in nonHiddenObj) {
			objNames += nonHiddenObj[i].nam[0];
			//(i < nonHiddenObj.length - 1) ? objNames += ', ' : objNames += '.'
			if(i == nonHiddenObj.length - 2) objNames += ' и '
			else if(i < nonHiddenObj.length - 1) objNames += ', '
			else objNames += '.'
		}
		if(nonHiddenObj.length == 0)
			objNames = ''
		t.print(window[player.loc].desc+objDesc+objNames)
	} else {
		(!obj.examined) ? obj.examined = 1 : obj.examined++
		t.print(obj.desc)
	}
}
*/

function inventory() {
	var inv = getObjByKV('loc', 'player');
	inv = inv.filter(function(item) {
		return !item.hiddenPossession
	})
	if(inv.length == 0) {
		t.print(game.playerHasNothingMsg)
	} else {
		var invObj = game.playerHasMsg;
		for(var i = 0; i < inv.length; i++) {
			invObj += inv[i].nam[0];
			if(inv[i].worn)invObj += ' (надет'+PARTICIPLE_SUFFIX[inv[i].gend]+')';
			//(i < inv.length - 1) ? invObj += ', ' : invObj += '.'
			if(i == inv.length - 2) invObj += ' и '
			else if(i < inv.length - 1) invObj += ', '
			else invObj += '.'
		}
		t.print(invObj)
	}
}

function score() {
	if(game.noScore)
		t.print(game.noScoreMsg)
	else {
		if(!game.maxScore)
			t.print('За '+game.turn+' ход'+numok(game.turn, '', 'а', 'ов')+' вы набрали '+game.points+' очк'+numok(game.points, 'о', 'а', 'ов')+'.')
		else
			t.print('За '+game.turn+' ход'+numok(game.turn, '', 'а', 'ов')+' вы набрали '+game.points+' очк'+numok(game.points, 'о', 'а', 'ов')+' из '+game.maxScore+' возможн'+numok(game.maxScore, 'ого', 'ых', 'ых')+'.')
	}
}

function loadGame(obj, optional, verb, fileName) {
	if(!game.noSaveLoad) {
		if(load(fileName)) {
			t.print(game.loadedMsg)
			window[player.loc].head && t.print('<br><b>'+window[player.loc].head+'</b>')
			examine()
		} else
			t.print(game.notLoadedMsg)
	} else
		t.print(game.loadForbiddenMsg)
}

function log(){var logWindow=window.document.open('','log','width=500,height=800')
	if(!logWindow) {
		t.print('Операция не может быть выполнена. Вероятно, в вашем браузере блокируются всплывающие окна.')
		return
	}
logWindow.document.body.innerHTML=game.logRecord
logWindow.document.title='Лог игры'+(game.title?' «'+game.title+'»':'')}

function remove(obj) {
	for(o in window) {
		if(window[o] && window[o].nam === obj.nam) {
			// quick fix of low-level bug
			//window[o] = undefined;
			window[o].loc = ''
			window[o].nam = ['', '', '', '', '', '']
			break
		}
	}
}

function reward(scores) {
	if(!game.noScore) {
		if(typeof scores == 'number') {
			scores > 0 && t.print('Ваш счёт увеличился на '+scores+' очк'+numok(scores, 'о', 'а', 'ов')+'.')
			scores < 0 && t.print('Ваш счёт уменьшился на '+Math.abs(scores)+' очк'+numok(scores, 'о', 'а', 'ов')+'.')
			game.points += scores
		}
	}
}

function numok(num, s1, s4, s5) {
	num = Math.abs(num)
	if(num != Math.round(num)) return s4
	if(num >= 100)
		num = num - 100*IntDiv(num, 100)
	if(num > 20 || num < 5) {
		num = num - 10*IntDiv(num, 10)
		if(num == 1) return s1
		else if (num == 2 || num == 3 || num == 4) return s4
		else return s5
	} else return s5
}

function IntDiv(dividend, divisor){
	return (dividend - dividend % divisor) / divisor
}

function end(mode) {
	mode == 1 && t.print(game.winMsg)
	mode == 0 && t.print(game.lostMsg)
	!game.noScore && score()
	t.print('Чтобы перезапустить игру и начать с начала, обновите страницу нажатием клавиши F5 или через меню вашего браузера.')
	game.stopped = true
}

function choiceHandler(com, comMode, noun, verb, optional) {
	if(comMode > 0 && noun == undefined) {
		if(com === 'saveGame')
			return t.print('Для сохранения игры необходимо указать название сохранения в виде произвольной строки без пробелов, например, «<em>сохранить уровень1</em>».')
		if(com === 'loadGame')
			return t.print('Для загрузки сохранённой игры необходимо указать название ранее сделанного сохранения, например, «<em>загрузить уровень1</em>».')
		return t.print('Что вы хотите '+verb+'?')
	}
if(comMode==0&&noun!=undefined)return t.print('Понятна только команда \«'+verb+'\».')
var handled=false
if(isNounValid(noun))var obj=getObjByKV('nam',noun)[0];if(noun===undefined||isNounValid(noun)||comMode==2){optional!='sysCom'&&game.turn++
(game.commandHistory.indexOf(noun?verb+' '+noun:verb)==-1&&com!='repeat'&&com!='history')&&game.commandHistory.unshift(noun?verb+' '+noun:verb)
if(game.commandHistory.length>game.commandHistoryLength)game.commandHistory.pop()
if(window[player.loc].head)visitedLocs[player.loc]=getObjByKV('spec','thing').filter(function(thing){return thing.examined&&thing.loc.indexOf(player.loc)!=-1}).map(function(obj){return obj.nam[3]})
if(typeof events.beforeAll==='function')handled=events.beforeAll(com,obj,optional,verb,noun)
if(!handled){if(comMode!=2&&noun!==undefined&&com in getObjByKV('nam',noun)[0])handled=getObjByKV('nam',noun)[0][com](obj,optional,verb,noun);else if(com in window[player.loc])handled=window[player.loc][com](obj,optional,verb,noun)
else if(window.globalVerbs&&com in globalVerbs)handled=globalVerbs[com](obj,optional,verb,noun)
if(!handled)game[com]?t.print(game[com]):window[com](obj,optional,verb,noun)}
if(typeof events.afterAll==='function')events.afterAll(com,obj,optional,verb,noun);}else
t.print(game.noThingMsg)}

// This code has been moved to the main file.
/*
function init(){clear();game.title&&t.print('<span style="font-weight: bold;">'+game.title+'</span>');game.author&&t.print('b󯮺 '+game.author);game.version&&t.print('å񲩿: '+game.version);game.year&&t.print('Į⸠'+game.year);game.license&&t.print('̨齺 '+game.license);game.ageRating&&t.print('î豠򳮻㡮䱠殨: '+game.ageRating);game.ifid&&t.print('<!-- UUID://'+game.ifid+'// -->');game.info&&t.print('<br><span style="font-style: italic;">'+game.info+'</span>');t.print('<br>')
game.stopped=false
game.commandHistory=[]
player.spec='player'
game.spec='game'
if(!window.events)window['events']={}
if(!window.globalVerbs)window['globalVerbs']={}
events.spec='events'
globalVerbs.spec='globalVerbs'
var things=getObjByKV('spec','thing')
for(var i in things)
gendDef.call(things[i])
gendDef.call(player)
save('initialState')
document.getElementsByTagName('title')[0].textContent=game.title
if(typeof events.onIntro==='function')events.onIntro()
move(player,player.loc)
player.moved--
if(game.tests)tests();inp();}
*/

window.onbeforeunload = function() {
	if(!game.stopped && game.turn > 0)
	return 'Если вы не выполнили сохранение игры через команду «сохранить [имя сохранения]», то весь прогресс будет потерян.'
}